Index: /branches/2013/dev_r3987_METO1_MERCATOR6_OBC_BDY_merge/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- /branches/2013/dev_r3987_METO1_MERCATOR6_OBC_BDY_merge/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3990)
+++ /branches/2013/dev_r3987_METO1_MERCATOR6_OBC_BDY_merge/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 3991)
@@ -79,6 +79,8 @@
       INTEGER  ::   jpbdtau, jpbdtas                       !   -       -
       INTEGER  ::   ib_bdy1, ib_bdy2, ib1, ib2             !   -       -
+      INTEGER  ::   i_offset, j_offset                     !   -       -
       INTEGER, POINTER  ::  nbi, nbj, nbr                  ! short cuts
-      REAL   , POINTER  ::  flagu, flagv                   !    -   -
+      REAL(wp), POINTER  ::  flagu, flagv                  !    -   -
+      REAL(wp), POINTER, DIMENSION(:,:)       ::   pmask    ! pointer to 2D mask fields
       REAL(wp) ::   zefl, zwfl, znfl, zsfl                 ! local scalars
       INTEGER, DIMENSION (2)                  ::   kdimsz
@@ -92,10 +94,10 @@
 
       !!
-      NAMELIST/nambdy/ nb_bdy, ln_coords_file, cn_coords_file,             &
-         &             ln_mask_file, cn_mask_file, nn_dyn2d, nn_dyn2d_dta, &
-         &             nn_dyn3d, nn_dyn3d_dta, nn_tra, nn_tra_dta,         &  
-         &             ln_tra_dmp, ln_dyn3d_dmp, rn_time_dmp,              &
+      NAMELIST/nambdy/ nb_bdy, ln_coords_file, cn_coords_file,                 &
+         &             ln_mask_file, cn_mask_file, cn_dyn2d, nn_dyn2d_dta,     &
+         &             cn_dyn3d, nn_dyn3d_dta, cn_tra, nn_tra_dta,             &  
+         &             ln_tra_dmp, ln_dyn3d_dmp, rn_time_dmp, rn_time_dmp_out, &
 #if defined key_lim2
-         &             nn_ice_lim2, nn_ice_lim2_dta,                       &
+         &             cn_ice_lim2, nn_ice_lim2_dta,                           &
 #endif
          &             ln_vol, nn_volctl, nn_rimwidth
@@ -128,9 +130,9 @@
       ln_mask_file      = .false.
       cn_mask_file(:)   = ''
-      nn_dyn2d(:)       = 0
+      cn_dyn2d(:)       = ''
       nn_dyn2d_dta(:)   = -1  ! uninitialised flag
-      nn_dyn3d(:)       = 0
+      cn_dyn3d(:)       = ''
       nn_dyn3d_dta(:)   = -1  ! uninitialised flag
-      nn_tra(:)         = 0
+      cn_tra(:)         = ''
       nn_tra_dta(:)     = -1  ! uninitialised flag
       ln_tra_dmp(:)     = .false.
@@ -138,5 +140,5 @@
       rn_time_dmp(:)    = 1.
 #if defined key_lim2
-      nn_ice_lim2(:)    = 0
+      cn_ice_lim2(:)    = ''
       nn_ice_lim2_dta(:)= -1  ! uninitialised flag
 #endif
@@ -172,11 +174,33 @@
 
         IF(lwp) WRITE(numout,*) 'Boundary conditions for barotropic solution:  '
-        SELECT CASE( nn_dyn2d(ib_bdy) )                  
-          CASE(jp_none)         ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
-          CASE(jp_frs)          ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
-          CASE(jp_flather)      ;   IF(lwp) WRITE(numout,*) '      Flather radiation condition'
-          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_dyn2d' )
+        SELECT CASE( cn_dyn2d(ib_bdy) )                  
+          CASE('none')         
+             IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+             dta_bdy(ib_bdy)%ll_ssh = .false.
+             dta_bdy(ib_bdy)%ll_u2d = .false.
+             dta_bdy(ib_bdy)%ll_v2d = .false.
+          CASE('frs')          
+             IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+             dta_bdy(ib_bdy)%ll_ssh = .false.
+             dta_bdy(ib_bdy)%ll_u2d = .true.
+             dta_bdy(ib_bdy)%ll_v2d = .true.
+          CASE('flather')      
+             IF(lwp) WRITE(numout,*) '      Flather radiation condition'
+             dta_bdy(ib_bdy)%ll_ssh = .true.
+             dta_bdy(ib_bdy)%ll_u2d = .true.
+             dta_bdy(ib_bdy)%ll_v2d = .true.
+          CASE('orlanski')     
+             IF(lwp) WRITE(numout,*) '      Orlanski (fully oblique) radiation condition with adaptive nudging'
+             dta_bdy(ib_bdy)%ll_ssh = .false.
+             dta_bdy(ib_bdy)%ll_u2d = .true.
+             dta_bdy(ib_bdy)%ll_v2d = .true.
+          CASE('orlanski_npo') 
+             IF(lwp) WRITE(numout,*) '      Orlanski (NPO) radiation condition with adaptive nudging'
+             dta_bdy(ib_bdy)%ll_ssh = .false.
+             dta_bdy(ib_bdy)%ll_u2d = .true.
+             dta_bdy(ib_bdy)%ll_v2d = .true.
+          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for cn_dyn2d' )
         END SELECT
-        IF( nn_dyn2d(ib_bdy) .gt. 0 ) THEN
+        IF( cn_dyn2d(ib_bdy) /= 'none' ) THEN
            SELECT CASE( nn_dyn2d_dta(ib_bdy) )                   ! 
               CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      initial state used for bdy data'        
@@ -193,12 +217,32 @@
 
         IF(lwp) WRITE(numout,*) 'Boundary conditions for baroclinic velocities:  '
-        SELECT CASE( nn_dyn3d(ib_bdy) )                  
-          CASE(jp_none)  ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
-          CASE(jp_frs)   ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
-          CASE( 2 )      ;   IF(lwp) WRITE(numout,*) '      Specified value'
-          CASE( 3 )      ;   IF(lwp) WRITE(numout,*) '      Zero baroclinic velocities (runoff case)'
-          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_dyn3d' )
+        SELECT CASE( cn_dyn3d(ib_bdy) )                  
+          CASE('none')
+             IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+             dta_bdy(ib_bdy)%ll_u3d = .false.
+             dta_bdy(ib_bdy)%ll_v3d = .false.
+          CASE('frs')       
+             IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+             dta_bdy(ib_bdy)%ll_u3d = .true.
+             dta_bdy(ib_bdy)%ll_v3d = .true.
+          CASE('specified')
+             IF(lwp) WRITE(numout,*) '      Specified value'
+             dta_bdy(ib_bdy)%ll_u3d = .true.
+             dta_bdy(ib_bdy)%ll_v3d = .true.
+          CASE('zero')
+             IF(lwp) WRITE(numout,*) '      Zero baroclinic velocities (runoff case)'
+             dta_bdy(ib_bdy)%ll_u3d = .false.
+             dta_bdy(ib_bdy)%ll_v3d = .false.
+          CASE('orlanski')
+             IF(lwp) WRITE(numout,*) '      Orlanski (fully oblique) radiation condition with adaptive nudging'
+             dta_bdy(ib_bdy)%ll_u3d = .true.
+             dta_bdy(ib_bdy)%ll_v3d = .true.
+          CASE('orlanski_npo')
+             IF(lwp) WRITE(numout,*) '      Orlanski (NPO) radiation condition with adaptive nudging'
+             dta_bdy(ib_bdy)%ll_u3d = .true.
+             dta_bdy(ib_bdy)%ll_v3d = .true.
+          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for cn_dyn3d' )
         END SELECT
-        IF( nn_dyn3d(ib_bdy) .gt. 0 ) THEN
+        IF( cn_dyn3d(ib_bdy) /= 'none' ) THEN
            SELECT CASE( nn_dyn3d_dta(ib_bdy) )                   ! 
               CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      initial state used for bdy data'        
@@ -209,8 +253,8 @@
 
         IF ( ln_dyn3d_dmp(ib_bdy) ) THEN
-           IF ( nn_dyn3d(ib_bdy).EQ.0 ) THEN
+           IF ( cn_dyn3d(ib_bdy) == 'none' ) THEN
               IF(lwp) WRITE(numout,*) 'No open boundary condition for baroclinic velocities: ln_dyn3d_dmp is set to .false.'
               ln_dyn3d_dmp(ib_bdy)=.false.
-           ELSEIF ( nn_dyn3d(ib_bdy).EQ.1 ) THEN
+           ELSEIF ( cn_dyn3d(ib_bdy) == 'frs' ) THEN
               CALL ctl_stop( 'Use FRS OR relaxation' )
            ELSE
@@ -218,4 +262,6 @@
               IF(lwp) WRITE(numout,*) '      Damping time scale: ',rn_time_dmp(ib_bdy),' days'
               IF((lwp).AND.rn_time_dmp(ib_bdy)<0) CALL ctl_stop( 'Time scale must be positive' )
+              dta_bdy(ib_bdy)%ll_u3d = .true.
+              dta_bdy(ib_bdy)%ll_v3d = .true.
            ENDIF
         ELSE
@@ -225,13 +271,36 @@
 
         IF(lwp) WRITE(numout,*) 'Boundary conditions for temperature and salinity:  '
-        SELECT CASE( nn_tra(ib_bdy) )                  
-          CASE(jp_none)  ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
-          CASE(jp_frs)   ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
-          CASE( 2 )      ;   IF(lwp) WRITE(numout,*) '      Specified value'
-          CASE( 3 )      ;   IF(lwp) WRITE(numout,*) '      Neumann conditions'
-          CASE( 4 )      ;   IF(lwp) WRITE(numout,*) '      Runoff conditions : Neumann for T and specified to 0.1 for salinity'
-          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_tra' )
+        SELECT CASE( cn_tra(ib_bdy) )                  
+          CASE('none')
+             IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+             dta_bdy(ib_bdy)%ll_tem = .false.
+             dta_bdy(ib_bdy)%ll_sal = .false.
+          CASE('frs')
+             IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+             dta_bdy(ib_bdy)%ll_tem = .true.
+             dta_bdy(ib_bdy)%ll_sal = .true.
+          CASE('specified')
+             IF(lwp) WRITE(numout,*) '      Specified value'
+             dta_bdy(ib_bdy)%ll_tem = .true.
+             dta_bdy(ib_bdy)%ll_sal = .true.
+          CASE('neumann')
+             IF(lwp) WRITE(numout,*) '      Neumann conditions'
+             dta_bdy(ib_bdy)%ll_tem = .false.
+             dta_bdy(ib_bdy)%ll_sal = .false.
+          CASE('runoff')
+             IF(lwp) WRITE(numout,*) '      Runoff conditions : Neumann for T and specified to 0.1 for salinity'
+             dta_bdy(ib_bdy)%ll_tem = .false.
+             dta_bdy(ib_bdy)%ll_sal = .false.
+          CASE('orlanski')
+             IF(lwp) WRITE(numout,*) '      Orlanski (fully oblique) radiation condition with adaptive nudging'
+             dta_bdy(ib_bdy)%ll_tem = .true.
+             dta_bdy(ib_bdy)%ll_sal = .true.
+          CASE('orlanski_npo')
+             IF(lwp) WRITE(numout,*) '      Orlanski (NPO) radiation condition with adaptive nudging'
+             dta_bdy(ib_bdy)%ll_tem = .true.
+             dta_bdy(ib_bdy)%ll_sal = .true.
+          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for cn_tra' )
         END SELECT
-        IF( nn_tra(ib_bdy) .gt. 0 ) THEN
+        IF( cn_tra(ib_bdy) /= 'none' ) THEN
            SELECT CASE( nn_tra_dta(ib_bdy) )                   ! 
               CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      initial state used for bdy data'        
@@ -242,13 +311,16 @@
 
         IF ( ln_tra_dmp(ib_bdy) ) THEN
-           IF ( nn_tra(ib_bdy).EQ.0 ) THEN
+           IF ( cn_tra(ib_bdy) == 'none' ) THEN
               IF(lwp) WRITE(numout,*) 'No open boundary condition for tracers: ln_tra_dmp is set to .false.'
               ln_tra_dmp(ib_bdy)=.false.
-           ELSEIF ( nn_tra(ib_bdy).EQ.1 ) THEN
+           ELSEIF ( cn_tra(ib_bdy) == 'frs' ) THEN
               CALL ctl_stop( 'Use FRS OR relaxation' )
            ELSE
               IF(lwp) WRITE(numout,*) '      + T/S relaxation zone'
               IF(lwp) WRITE(numout,*) '      Damping time scale: ',rn_time_dmp(ib_bdy),' days'
+              IF(lwp) WRITE(numout,*) '      Outflow damping time scale: ',rn_time_dmp_out(ib_bdy),' days'
               IF((lwp).AND.rn_time_dmp(ib_bdy)<0) CALL ctl_stop( 'Time scale must be positive' )
+              dta_bdy(ib_bdy)%ll_tem = .true.
+              dta_bdy(ib_bdy)%ll_sal = .true.
            ENDIF
         ELSE
@@ -259,10 +331,18 @@
 #if defined key_lim2
         IF(lwp) WRITE(numout,*) 'Boundary conditions for sea ice:  '
-        SELECT CASE( nn_ice_lim2(ib_bdy) )                  
-          CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      no open boundary condition'        
-          CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
-          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for nn_tra' )
+        SELECT CASE( cn_ice_lim2(ib_bdy) )                  
+          CASE('none')
+             IF(lwp) WRITE(numout,*) '      no open boundary condition'        
+             dta_bdy(ib_bdy)%ll_frld  = .false.
+             dta_bdy(ib_bdy)%ll_hicif = .false.
+             dta_bdy(ib_bdy)%ll_hsnif = .false.
+          CASE('frs')
+             IF(lwp) WRITE(numout,*) '      Flow Relaxation Scheme'
+             dta_bdy(ib_bdy)%ll_frld  = .true.
+             dta_bdy(ib_bdy)%ll_hicif = .true.
+             dta_bdy(ib_bdy)%ll_hsnif = .true.
+          CASE DEFAULT   ;   CALL ctl_stop( 'unrecognised value for cn_ice_lim2' )
         END SELECT
-        IF( nn_ice_lim2(ib_bdy) .gt. 0 ) THEN 
+        IF( cn_ice_lim2(ib_bdy) /= 'none' ) THEN 
            SELECT CASE( nn_ice_lim2_dta(ib_bdy) )                   ! 
               CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      initial state used for bdy data'        
@@ -744,8 +824,6 @@
                IF(lwp) THEN         ! Since all procs read global data only need to do this check on one proc...
                   IF( nbrdta(ib,igrd,ib_bdy) < nbrdta(ibm1,igrd,ib_bdy) ) THEN
-                     CALL ctl_stop('bdy_init : ERROR : boundary data in file  &
-                                    must be defined in order of distance from edge nbr.', &
-                                   'A utility for re-ordering boundary coordinates and data &
-                                    files exists in the TOOLS/OBC directory')
+                     CALL ctl_stop('bdy_init : ERROR : boundary data in file must be defined in order of distance from edge nbr.', &
+                                   'A utility for re-ordering boundary coordinates and data files exists in the TOOLS/OBC directory')
                   ENDIF    
                ENDIF
@@ -770,8 +848,9 @@
          ALLOCATE( idx_bdy(ib_bdy)%nbr(ilen1,jpbgrd) )
          ALLOCATE( idx_bdy(ib_bdy)%nbd(ilen1,jpbgrd) )
+         ALLOCATE( idx_bdy(ib_bdy)%nbdout(ilen1,jpbgrd) )
          ALLOCATE( idx_bdy(ib_bdy)%nbmap(ilen1,jpbgrd) )
          ALLOCATE( idx_bdy(ib_bdy)%nbw(ilen1,jpbgrd) )
-         ALLOCATE( idx_bdy(ib_bdy)%flagu(ilen1) )
-         ALLOCATE( idx_bdy(ib_bdy)%flagv(ilen1) )
+         ALLOCATE( idx_bdy(ib_bdy)%flagu(ilen1,jpbgrd) )
+         ALLOCATE( idx_bdy(ib_bdy)%flagv(ilen1,jpbgrd) )
 
          ! Dispatch mapping indices and discrete distances on each processor
@@ -941,4 +1020,5 @@
             ENDDO
          ENDDO 
+
          ! definition of the i- and j- direction local boundaries arrays
          ! used for sending the boudaries
@@ -994,4 +1074,6 @@
                nbr => idx_bdy(ib_bdy)%nbr(ib,igrd)
                idx_bdy(ib_bdy)%nbd(ib,igrd) = 1. / ( rn_time_dmp(ib_bdy) * rday ) & 
+               & *(FLOAT(nn_rimwidth(ib_bdy)+1-nbr)/FLOAT(nn_rimwidth(ib_bdy)))**2.   ! quadratic
+               idx_bdy(ib_bdy)%nbdout(ib,igrd) = 1. / ( rn_time_dmp_out(ib_bdy) * rday ) & 
                & *(FLOAT(nn_rimwidth(ib_bdy)+1-nbr)/FLOAT(nn_rimwidth(ib_bdy)))**2.   ! quadratic
             END DO
@@ -1096,4 +1178,13 @@
       ENDDO
 
+      ! bdyfmask required for flagu, flagv calculations below even though F-points 
+      ! not defined for BDY grid. 
+      DO ij = 2, jpjm1
+         DO ii = 2, jpim1
+            bdyfmask(ii,ij) = bdytmask(ii,ij  ) * bdytmask(ii+1,ij  )   &
+           &                * bdytmask(ii,ij+1) * bdytmask(ii+1,ij+1)
+         END DO      
+      END DO
+
       ! Lateral boundary conditions
       CALL lbc_lnk( fmask        , 'F', 1. )   ;   CALL lbc_lnk( bdytmask(:,:), 'T', 1. )
@@ -1102,52 +1193,95 @@
       DO ib_bdy = 1, nb_bdy       ! Indices and directions of rim velocity components
 
-         idx_bdy(ib_bdy)%flagu(:) = 0.e0
-         idx_bdy(ib_bdy)%flagv(:) = 0.e0
+         idx_bdy(ib_bdy)%flagu(:,:) = 0.e0
+         idx_bdy(ib_bdy)%flagv(:,:) = 0.e0
          icount = 0 
 
-         !flagu = -1 : u component is normal to the dynamical boundary but its direction is outward
-         !flagu =  0 : u is tangential
-         !flagu =  1 : u is normal to the boundary and is direction is inward
+         ! Calculate relationship of U direction to the local orientation of the boundary
+         ! flagu = -1 : u component is normal to the dynamical boundary and its direction is outward
+         ! flagu =  0 : u is tangential
+         ! flagu =  1 : u is normal to the boundary and is direction is inward
   
-         igrd = 2      ! u-component 
-         DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)  
-            nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
-            nbj => idx_bdy(ib_bdy)%nbj(ib,igrd)
-            zefl = bdytmask(nbi  ,nbj)
-            zwfl = bdytmask(nbi+1,nbj)
-            IF( zefl + zwfl == 2 ) THEN
-               icount = icount + 1
-            ELSE
-               idx_bdy(ib_bdy)%flagu(ib)=-zefl+zwfl
-            ENDIF
+         DO igrd = 1,jpbgrd 
+            SELECT CASE( igrd )
+               CASE( 1 )
+                  cgrid = 'T' 
+                  pmask => umask(:,:,1)
+                  i_offset = 0
+               CASE( 2 ) 
+                  cgrid = 'U'
+                  pmask => bdytmask
+                  i_offset = 1
+               CASE( 3 ) 
+                  cgrid = 'V'
+                  pmask => fmask(:,:,1)
+                  i_offset = 0
+            END SELECT 
+            icount = 0
+            DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)  
+               nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
+               nbj => idx_bdy(ib_bdy)%nbj(ib,igrd)
+               zefl = pmask(nbi+i_offset-1,nbj)
+               zwfl = pmask(nbi+i_offset,nbj)
+               IF( zefl + zwfl == 2 * i_offset ) THEN
+                  icount = icount + 1
+                  IF(lwp) WRITE(numout,*) 'Problem with igrd = ',igrd,' at (global) nbi, nbj : ',mig(nbi),mjg(nbj)
+               ELSE
+                  idx_bdy(ib_bdy)%flagu(ib,igrd)=-zefl+zwfl
+               ENDIF
+            END DO
+            IF( icount /= 0 ) THEN
+               IF(lwp) WRITE(numout,*)
+               IF(lwp) WRITE(numout,*) ' E R R O R : Some ',cgrid,' grid points,',   &
+                  ' are not boundary points (flagu calculation). Check nbi, nbj, indices for boundary set ',ib_bdy
+               IF(lwp) WRITE(numout,*) ' ========== '
+               IF(lwp) WRITE(numout,*)
+               nstop = nstop + 1
+            ENDIF 
          END DO
 
-         !flagv = -1 : u component is normal to the dynamical boundary but its direction is outward
-         !flagv =  0 : u is tangential
-         !flagv =  1 : u is normal to the boundary and is direction is inward
-
-         igrd = 3      ! v-component
-         DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)  
-            nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
-            nbj => idx_bdy(ib_bdy)%nbj(ib,igrd)
-            znfl = bdytmask(nbi,nbj  )
-            zsfl = bdytmask(nbi,nbj+1)
-            IF( znfl + zsfl == 2 ) THEN
-               icount = icount + 1
-            ELSE
-               idx_bdy(ib_bdy)%flagv(ib) = -znfl + zsfl
-            END IF
+         ! Calculate relationship of V direction to the local orientation of the boundary
+         ! flagv = -1 : u component is normal to the dynamical boundary but its direction is outward
+         ! flagv =  0 : u is tangential
+         ! flagv =  1 : u is normal to the boundary and is direction is inward
+
+         DO igrd = 1,jpbgrd 
+            SELECT CASE( igrd )
+               CASE( 1 )
+                  cgrid = 'T'
+                  pmask => vmask(:,:,1)
+                  j_offset = 0
+               CASE( 2 )
+                  cgrid = 'U'
+                  pmask => fmask(:,:,1)
+                  j_offset = 0
+               CASE( 3 )
+                  cgrid = 'V'
+                  pmask => bdytmask
+                  j_offset = 1
+            END SELECT 
+            icount = 0
+            DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)  
+               nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
+               nbj => idx_bdy(ib_bdy)%nbj(ib,igrd)
+               znfl = pmask(nbi,nbj+j_offset-1  )
+               zsfl = pmask(nbi,nbj+j_offset)
+               IF( znfl + zsfl == 2 * j_offset ) THEN
+                  IF(lwp) WRITE(numout,*) 'Problem with igrd = ',igrd,' at (global) nbi, nbj : ',mig(nbi),mjg(nbj)
+                  icount = icount + 1
+               ELSE
+                  idx_bdy(ib_bdy)%flagv(ib,igrd) = -znfl + zsfl
+               END IF
+            END DO
+            IF( icount /= 0 ) THEN
+               IF(lwp) WRITE(numout,*)
+               IF(lwp) WRITE(numout,*) ' E R R O R : Some ',cgrid,' grid points,',   &
+                  ' are not boundary points (flagv calculation). Check nbi, nbj, indices for boundary set ',ib_bdy
+               IF(lwp) WRITE(numout,*) ' ========== '
+               IF(lwp) WRITE(numout,*)
+               nstop = nstop + 1
+            ENDIF 
          END DO
 
-         IF( icount /= 0 ) THEN
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) ' E R R O R : Some data velocity points,',   &
-               ' are not boundary points. Check nbi, nbj, indices for boundary set ',ib_bdy
-            IF(lwp) WRITE(numout,*) ' ========== '
-            IF(lwp) WRITE(numout,*)
-            nstop = nstop + 1
-         ENDIF 
-    
-      ENDDO
+      END DO
 
       ! Compute total lateral surface for volume correction:
@@ -1161,5 +1295,5 @@
                nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
                nbj => idx_bdy(ib_bdy)%nbj(ib,igrd)
-               flagu => idx_bdy(ib_bdy)%flagu(ib)
+               flagu => idx_bdy(ib_bdy)%flagu(ib,igrd)
                bdysurftot = bdysurftot + hu     (nbi  , nbj)                           &
                   &                    * e2u    (nbi  , nbj) * ABS( flagu ) &
@@ -1174,5 +1308,5 @@
                nbi => idx_bdy(ib_bdy)%nbi(ib,igrd)
                nbj => idx_bdy(ib_bdy)%nbj(ib,igrd)
-               flagv => idx_bdy(ib_bdy)%flagv(ib)
+               flagv => idx_bdy(ib_bdy)%flagv(ib,igrd)
                bdysurftot = bdysurftot + hv     (nbi, nbj  )                           &
                   &                    * e1v    (nbi, nbj  ) * ABS( flagv ) &
@@ -1584,7 +1718,7 @@
       itest = 0
 
-      IF (nn_dyn2d(ib1)/=nn_dyn2d(ib2)) itest = itest + 1
-      IF (nn_dyn3d(ib1)/=nn_dyn3d(ib2)) itest = itest + 1
-      IF (nn_tra(ib1)/=nn_tra(ib2)) itest = itest + 1
+      IF (cn_dyn2d(ib1)/=cn_dyn2d(ib2)) itest = itest + 1
+      IF (cn_dyn3d(ib1)/=cn_dyn3d(ib2)) itest = itest + 1
+      IF (cn_tra(ib1)/=cn_tra(ib2)) itest = itest + 1
       !
       IF (nn_dyn2d_dta(ib1)/=nn_dyn2d_dta(ib2)) itest = itest + 1
